Calc3D	MACRO
 move.l	 Object_Points,a0
 lea	 sintable+$80,a1	; CosTable
 lea	 sintable,a2		; SinTable
 move.l	 HandlePtsPtr,a6
 move.l	 HandleZPtr,a5
 move.w  Object_NbPoints,d7
RepPoints:
 move.w  d7,-(a7)		;
 move.w  (a0)+,d0
 ext.l	 d0
 move.w  (a0)+,d1
 ext.l	 d1
 move.w  (a0)+,d2
 ext.l	 d2

 clr.w	 d3			;
 move.b  vy,d3
 lsl	 #1,d3
 move.w  0(a1,d3),d4   		; d4=yc
 move.w  0(a2,d3),d5   		; d5=ys
 ext.l	 d4
 ext.l	 d5

 move.l  d0,d6
 muls	 d4,d6	       		; d6=x*yc
 move.l  d2,d7
 muls	 d5,d7			; d7=ys*z
 sub.l	 d7,d6	
 asr.l	 #8,d6
 asr.l   #4,d6
 move.l  d6,a3	       		; a3=(yc*x-ys*z)/factor (xt)
 move.l  d0,d6
 muls	 d5,d6
 move.l  d2,d7
 muls	 d4,d7
 add.l	 d6,d7
 asr.l	 #8,d7
 asr.l   #4,d7
 move.l  d7,a4	       		; a4=(ys*x+yc*z)/factor (zt)

 clr.w	 d3			;
 move.b  vz,d3
 lsl.w	 #1,d3
 move.w  0(a1,d3),d4   		; d4=zc
 move.w  0(a2,d3),d5   		; d5=zs

 move.l  a3,d6
 muls	 d4,d6
 move.l  d1,d7
 muls	 d5,d7
 add.l	 d6,d7
 asr.l	 #8,d7
 asr.l   #4,d7
 move.l  d7,d0	       		; d0=(zc*xt+zs*y) DIV faktor (x)
 move.l  d1,d6
 muls	 d4,d6
 move.l  a3,d7
 muls	 d5,d7
 sub.l	 d7,d6
 asr.l	 #8,d6
 asr.l   #4,d6

 move.l	 a5,-(a7)		;

 move.w  d6,a5	        	; a5=(zc*y-zs*xt) DIV faktor (yt)

 clr.w	 d3			;
 move.b  vx,d3
 lsl	 #1,d3
 move.w  0(a1,d3),d4    	; d4=xc
 move.w  0(a2,d3),d5    	; d5=xs

 move.l  a4,d6
 muls	 d4,d6
 move.l  a5,d7
 muls	 d5,d7
 sub.l	 d7,d6
 asr.l	 #8,d6
 asr.l   #4,d6
 move.l  d6,d2	        	; d2=(xc*zt-xs*yt) DIV faktor (z)
 move.l  a5,d6
 muls	 d4,d6
 move.l  a4,d7
 muls	 d5,d7
 add.l	 d6,d7
 asr.l	 #8,d7
 asr.l	 #4,d7
 move.l  d7,d1	        	; d1=(xs*zt+xc*yt) DIV faktor (y)

 move.l	 (a7)+,a5		;
 
 move.w	 ZFactor,d7
 sub.w	 d7,d2

 move.w	 d2,(a5)+		;


 beq DivZero
 lsl.l	 #8,d0
 lsl.l	 #2,d0
 move.l  d0,d4
 divs	 d2,d4
 ext.l	 d4
 add.l	 #XCenter,d4		;X Screen Center
 lsl.l	 #8,d1
 lsl.l	 #2,d1
 move.l  d1,d5
 divs	 d2,d5
 ext.l	 d5
 add.l	 #YCenter,d5		;Y Screen Center
 bra PutPoint
DivZero:
 move.l  #XCenter,d4
 move.l  #YCenter,d5
PutPoint:
 move.w  d4,(a6)+
 move.w  d5,(a6)+
 move.w  (a7)+,d7	;
 dbra	 d7,RepPoints
; rts
	ENDM
;***************************************************





;***************************************************
FindViewScreen	MACRO
 lea	 sintable+$80,a1
 lea	 sintable,a2
 move.w	 xc,d0
 move.w  yc,d1
 lsl.l	 #8,d0		
 lsl.l	 #4,d0			; d0 = d0 * 2^12
 lsl.l	 #8,d1
 lsl.l	 #4,d1			; d1 = d1 * 2^12
 
 clr.w	 d3
 move.b  rot,d3
 add.b	 #21,d3			;(21)b256 = (30)b360
 lsl.w	 #1,d3
 move.w  0(a1,d3.w),d4   	; d4=cos(rot+30)
 move.w  0(a2,d3.w),d5   	; d5=sin(rot+30)
 ext.l	 d4
 ext.l	 d5
 asl.l	 #7,d4			; d4=128*cos(rot+30)
 asl.l	 #7,d5			; d5=128*sin(rot+30)

 clr.w	 d3
 move.b  rot,d3
 sub.b	 #21,d3			;(21)b256 = (30)b360
 lsl.w	 #1,d3
 move.w  0(a1,d3.w),d2   	; d2=cos(rot-30)
 move.w  0(a2,d3.w),d3   	; d3=sin(rot-30)
 ext.l	 d2
 ext.l	 d3
 asl.l	 #7,d2			; d2=128*cos(rot-30)
 asl.l	 #7,d3			; d3=128*sin(rot-30)

 add.l	 d0,d4			; x1=d4=d4+xc
 add.l	 d1,d5			; y1=d5=d5+yc
 add.l	 d0,d2			; x2=d2=d2+xc
 add.l   d1,d3			; y2=d3=d3+yc

; Now, each coordonnate should be positive and in the range [0,16*(nbr of Cell of the world)]


	CalculEncadrement


CalculEnd:
; d6 = min(xc,min(x1,x2))
; d7 = max(xc,max(x1,x2))
; d4 = min(yc,min(y1,y2))
; d2 = min(yc,min(y1,y2))
 lsr.l	#8,d6
 lsr.l	#8,d7
 lsr.l	#8,d4
 lsr.l	#8,d2

 lsr.w	#4,d6
 lsr.w	#4,d7
 lsr.w	#4,d4
 lsr.w	#4,d2

 GetConcernedPoints d6,d7,d4,d2






 

	ENDM
;**********************************************************************




;**********************************************************************
GetConcernedPoints	MACRO
 lea	 Surface,a0
 lea	 ConcernedPts,a1
 lea	 SurfaceColor,a4

  

 lsl.w	#4,d6
 lsl.w	#4,d7
 lsl.w	#4,d4
 lsl.w	#4,d2
 

 move.w	d6,(a1)+	; x
 move.w	d4,(a0)+	; y
 move.w 0(a1,





	ENDM
;**********************************************************************




;**********************************************************************
CalculEncadrement	MACRO
Calculv1:
; d6 = min(xc,min(x1,x2))
 cmp.l	 d4,d2
 bge	 x1INFx2
 cmp.l	 d0,d2			; x2<x1
 bge	 xcINFx2
 move.l	 d2,d6			; v1=d6 <- x2 ; x2<xc
 bra	 Calculv2
xcINFx2:
 move.l  d0,d6			; v1=d6 <- xc
 bra	 Calculv2
x1INFx2:
 cmp.l	 d0,d4
 bge	 xcINFx1
 move.l	 d4,d6			; v1=d6 <- x2 ; x2<xc
 bra	 Calculv2 
xcINFx1:
 move.l	 d0,d6			; v1=d6 <- xc
 bra	 Calculv2

Calculv2:
; d7 = max(xc,max(x1,x2))
 cmp.l	 d4,d2
 blt	 x1SUPx2
 cmp.l	 d0,d2			; x2>x1
 blt	 xcSUPx2
 move.l	 d2,d7			; v2=d7 <- x2 ; x2>xc
 bra	 Calculh1
xcSUPx2:
 move.l  d0,d7			; v2=d7 <- xc
 bra	 Calculh1
x1SUPx2:
 cmp.l	 d0,d4
 blt	 xcSUPx1
 move.l	 d4,d7			; v2=d7 <- x2 ; x2>xc
 bra	 Calculh1
xcSUPx1:
 move.l	 d0,d7			; v2=d7 <- xc
 bra	 Calculh1


Calculh1:
; d4 = min(yc,min(y1,y2))
 cmp.l	 d5,d3
 bge	 y1INFy2
 cmp.l	 d1,d3			; y2<y1
 bge	 ycINFy2
 move.l	 d3,d4			; v1=d4 <- y2 ; y2<yc
 bra	 Calculh2
ycINFy2:
 move.l  d1,d4			; v1=d4 <- yc
 bra	 Calculh2
y1INFy2:
 cmp.l	 d1,d5
 bge	 ycINFy1
 move.l	 d5,d4			; v1=d4 <- y2 ; y2<yc
 bra	 Calculh2 
ycINFy1:
 move.l	 d1,d4			; v1=d4 <- yc
 bra	 Calculh2
 
 
Calculh2:
; d2 = min(yc,min(y1,y2))
 cmp.l	 d5,d3
 blt	 y1SUPy2
 cmp.l	 d1,d3			; y2>y1
 blt	 ycSUPy2
 move.l	 d3,d2			; v1=d2 <- y2 ; y2>yc
 bra	 CalculEnd
ycSUPy2:
 move.l  d1,d2			; v1=d2 <- yc
 bra	 CalculEnd
y1SUPy2:
 cmp.l	 d1,d5
 blt	 ycSUPy1
 move.l	 d5,d2			; v1=d2 <- y2 ; y2>yc
 bra	 CalculEnd
ycSUPy1:
 move.l	 d1,d2			; v1=d2 <- yc
; bra	 CalculEnd
	ENDM
;**********************************************************************




;**********************************************************************
CalcSurface3D	MACRO
 lea	 Surface,a0
 lea	 sintable+$80,a1
 lea	 sintable,a2
 move.l	 HandlePtsPtr,a6
 move.l	 HandleZPtr,a5
 move.w  #16,d7			;nbre de points
RepPoints:
 move.w  d7,-(a7)
				;Find ou est la camera dans l'array




 move.w  (a0)+,d0
 ext.l	 d0
 move.w  (a0)+,d1
 ext.l	 d1
 move.w  (a0)+,d2
 ext.l	 d2

 clr.w	 d3			;
 move.b  vy,d3
 lsl	 #1,d3
 move.w  0(a1,d3),d4   		; d4=yc
 move.w  0(a2,d3),d5   		; d5=ys
 ext.l	 d4
 ext.l	 d5

 move.l  d0,d6
 muls	 d4,d6	       		; d6=x*yc
 move.l  d2,d7
 muls	 d5,d7			; d7=ys*z
 sub.l	 d7,d6	
 asr.l	 #8,d6
 asr.l   #4,d6
 move.l  d6,a3	       		; a3=(yc*x-ys*z)/factor (xt)
 move.l  d0,d6
 muls	 d5,d6
 move.l  d2,d7
 muls	 d4,d7
 add.l	 d6,d7
 asr.l	 #8,d7
 asr.l   #4,d7
 move.l  d7,a4	       		; a4=(ys*x+yc*z)/factor (zt)

 clr.w	 d3			;
 move.b  vz,d3
 lsl.w	 #1,d3
 move.w  0(a1,d3),d4   		; d4=zc
 move.w  0(a2,d3),d5   		; d5=zs

 move.l  a3,d6
 muls	 d4,d6
 move.l  d1,d7
 muls	 d5,d7
 add.l	 d6,d7
 asr.l	 #8,d7
 asr.l   #4,d7
 move.l  d7,d0	       		; d0=(zc*xt+zs*y) DIV faktor (x)
 move.l  d1,d6
 muls	 d4,d6
 move.l  a3,d7
 muls	 d5,d7
 sub.l	 d7,d6
 asr.l	 #8,d6
 asr.l   #4,d6

 move.l	 a5,-(a7)		;

 move.w  d6,a5	        	; a5=(zc*y-zs*xt) DIV faktor (yt)

 clr.w	 d3			;
 move.b  vx,d3
 lsl	 #1,d3
 move.w  0(a1,d3),d4    	; d4=xc
 move.w  0(a2,d3),d5    	; d5=xs

 move.l  a4,d6
 muls	 d4,d6
 move.l  a5,d7
 muls	 d5,d7
 sub.l	 d7,d6
 asr.l	 #8,d6
 asr.l   #4,d6
 move.l  d6,d2	        	; d2=(xc*zt-xs*yt) DIV faktor (z)
 move.l  a5,d6
 muls	 d4,d6
 move.l  a4,d7
 muls	 d5,d7
 add.l	 d6,d7
 asr.l	 #8,d7
 asr.l	 #4,d7
 move.l  d7,d1	        	; d1=(xs*zt+xc*yt) DIV faktor (y)

 move.l	 (a7)+,a5		;
 
 move.w	 ZFactor,d7
 sub.w	 d7,d2

 move.w	 d2,(a5)+		;


 beq DivZero
 lsl.l	 #8,d0
 lsl.l	 #2,d0
 move.l  d0,d4
 divs	 d2,d4
 ext.l	 d4
 add.l	 #XCenter,d4		;X Screen Center
 lsl.l	 #8,d1
 lsl.l	 #2,d1
 move.l  d1,d5
 divs	 d2,d5
 ext.l	 d5
 add.l	 #YCenter,d5		;Y Screen Center
 bra PutPoint
DivZero:
 move.l  #XCenter,d4
 move.l  #YCenter,d5
PutPoint:
 move.w  d4,(a6)+
 move.w  d5,(a6)+
 move.w  (a7)+,d7	;
 dbra	 d7,RepPoints
; rts
;***************************************************
	ENDM

CalcAxes3D	MACRO
 lea.l	 Axes_Points,a0
 lea.l	 sintable+$80,a1
 lea.l	 sintable,a2
 lea.l	 AxesPts,a6
; move.l	 HandleZPtr,a5
 move.w  #3,d7		;
RepPointsAxes:
 move.w  d7,-(a7)		;
 move.w  (a0)+,d0
 ext.l	 d0
 move.w  (a0)+,d1
 ext.l	 d1
 move.w  (a0)+,d2
 ext.l	 d2

 clr.w	 d3		;
 move.b  vy,d3
 lsl	 #1,d3
 move.w  0(a1,d3),d4   ; d4=yc
 move.w  0(a2,d3),d5   ; d5=ys
 ext.l	 d4
 ext.l	 d5

 move.l  d0,d6
 muls	 d4,d6	       ; d6=x*yc
 move.l  d2,d7
 muls	 d5,d7	       ; d7=ys*z
 sub.l	 d7,d6
 asr.l	 #8,d6
 asr.l   #4,d6
 move.l  d6,a3	       	; a3=(yc*x-ys*z)/factor (xt)
 move.l  d0,d6
 muls	 d5,d6
 move.l  d2,d7
 muls	 d4,d7
 add.l	 d6,d7
 asr.l	 #8,d7
 asr.l   #4,d7
 move.l  d7,a4	       	; a4=(ys*x+yc*z)/factor (zt)

 clr.w	 d3		;
 move.b  vz,d3
 lsl.w	 #1,d3
 move.w  0(a1,d3),d4   	; d4=zc
 move.w  0(a2,d3),d5   	; d5=zs

 move.l  a3,d6
 muls	 d4,d6
 move.l  d1,d7
 muls	 d5,d7
 add.l	 d6,d7
 asr.l	 #8,d7
 asr.l   #4,d7
 move.l  d7,d0	       	; d0=(zc*xt+zs*y) DIV faktor (x)
 move.l  d1,d6
 muls	 d4,d6
 move.l  a3,d7
 muls	 d5,d7
 sub.l	 d7,d6
 asr.l	 #8,d6
 asr.l   #4,d6

; move.l	 a5,-(a7)	;

 move.w  d6,a5	        ; a5=(zc*y-zs*xt) DIV faktor (yt)

 clr.w	 d3		;
 move.b  vx,d3
 lsl	 #1,d3
 move.w  0(a1,d3),d4    ; d4=xc
 move.w  0(a2,d3),d5    ; d5=xs

 move.l  a4,d6
 muls	 d4,d6
 move.l  a5,d7
 muls	 d5,d7
 sub.l	 d7,d6
 asr.l	 #8,d6
 asr.l   #4,d6
 move.l  d6,d2	        ; d2=(xc*zt-xs*yt) DIV faktor (z)
 move.l  a5,d6
 muls	 d4,d6
 move.l  a4,d7
 muls	 d5,d7
 add.l	 d6,d7
 asr.l	 #8,d7
 asr.l	 #4,d7
 move.l  d7,d1	        ; d1=(xs*zt+xc*yt) DIV faktor (y)

; move.l	 (a7)+,a5	;
 
; move.w	 ZFactor,d7
; sub.w	 d7,d2
 sub.w	#1024,d2

; move.w	 d2,(a5)+	;


 beq DivZeroAxes
 lsl.l	 #8,d0
 lsl.l	 #2,d0
 move.l  d0,d4
 divs	 d2,d4
 ext.l	 d4
 add.l	 #XCenter,d4	;X Screen Center
 lsl.l	 #8,d1
 lsl.l	 #2,d1
 move.l  d1,d5
 divs	 d2,d5
 ext.l	 d5
 add.l	 #YCenter,d5		;Y Screen Center
 bra PutPointAxes
DivZeroAxes:
 move.l  #XCenter,d4
 move.l  #YCenter,d5
PutPointAxes:
 move.w  d4,(a6)+
 move.w  d5,(a6)+
 move.w  (a7)+,d7	;
 dbra	 d7,RepPointsAxes
; rts
	ENDM



